﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Globalization;
using Syncfusion.SfPicker.XForms;
using Xamarin.Forms;

namespace picker132913
{
    public class CustomDatePicker : SfPicker
    {
		#region Public Properties

		// Months api is used to modify the Day collection as per change in Month

		internal Dictionary<string, string> Months { get; set; }

		/// <summary>
		/// Date is the acutal DataSource for SfPicker control which will holds the collection of Day ,Month and Year
		/// </summary>
		/// <value>The date.</value>
		public ObservableCollection<object> DateColumns { get; set; }

		//Day is the collection of day numbers
		internal ObservableCollection<object> Day { get; set; }

		//Month is the collection of Month Names
		internal ObservableCollection<object> Month { get; set; }

		//Year is the collection of Years from 1990 to 2042
		internal ObservableCollection<object> Year { get; set; }

		/// <summary>
		/// Headers api is holds the column name for every column in date picker
		/// </summary>
		/// <value>The Headers.</value>
		public ObservableCollection<string> Headers { get; set; }

		public DateTime Date { get; set; }

		#endregion

		public CustomDatePicker()
		{
			//this.BackgroundColor = (Color)Application.Current.Resources["ContentGridColour"];
			//this.UnSelectedItemTextColor = (Color)Application.Current.Resources["DefaultTextColour"];
			this.SelectedItemFontAttribute = FontAttributes.Bold;
			this.ColumnHeaderTextColor = Color.FromHex("#b3b3cc");// (Color)Application.Current.Resources["DefaultTextColour"];
			//this.ColumnHeaderBackgroundColor = (Color)Application.Current.Resources["HeaderBarColour"];
			this.ColumnHeaderFontSize = Device.Idiom == TargetIdiom.Phone ? 18 : 22;
			//this.BorderColor = (Color)Application.Current.Resources["HeaderBarColour"];
			//this.ColumnHeaderFontAttribute = FontAttributes.Bold;

			Months = new Dictionary<string, string>();

			DateColumns = new ObservableCollection<object>();
			Day = new ObservableCollection<object>();
			Month = new ObservableCollection<object>();
			Year = new ObservableCollection<object>();
			Headers = new ObservableCollection<string>();
			Headers.Add("Day");
			Headers.Add("Month");
			Headers.Add("Year");
			PopulateDateCollection();
			this.ItemsSource = DateColumns;
            ObservableCollection<object> coll = new System.Collections.ObjectModel.ObservableCollection<object>();
            var col1 = DateColumns[0];
            var first = col1 as ObservableCollection<object>;
			var col2 = DateColumns[1];
			var second = col2 as ObservableCollection<object>;
			var col3 = DateColumns[2];
			var third = col3 as ObservableCollection<object>;
            coll.Add(first[0]);
            coll.Add(second[0]);
            coll.Add(third[0]);
            this.SelectedItem = coll;
			this.ColumnHeaderText = Headers;
			ShowFooter = false;
			ShowHeader = false;
			ShowColumnHeader = true;

		}

		private void PopulateDateCollection()
		{

			//populate months
			for (int i = 1; i < 13; i++)
			{
                Month.Add(i);
				//if (!Months.ContainsKey(CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(i)))
				//	Months.Add(CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(i), CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(i));
				//Month.Add(CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(i));
			}

			//populate year
			for (int i = 2016; i < DateTime.Today.Year + 4; i++)
			{
				Year.Add(i.ToString());
			}

			//populate Days
			for (int i = 1; i <= DateTime.DaysInMonth(DateTime.Now.Year, DateTime.Now.Month); i++)
			{
				Day.Add(i.ToString("00"));
			}

			DateColumns.Add(Day);
			DateColumns.Add(Month);
			DateColumns.Add(Year);
		}

		public static readonly BindableProperty SelectedDateProperty = BindableProperty.Create(nameof(SelectedDate), typeof(DateTime), typeof(Picker), DateTime.MinValue, defaultBindingMode: BindingMode.TwoWay,
		propertyChanged: (b, o, n) =>
		{
			var datetime = (DateTime)n;
			if (datetime != DateTime.MinValue)
			{
				var selectedItem = new ObservableCollection<object>();
				selectedItem.Add(datetime.Day.ToString("00"));
				
                //selectedItem.Add(datetime.Month);
                selectedItem.Add(CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(datetime.Month));
				selectedItem.Add(datetime.Year.ToString());
				if (((Picker)b).SelectedItem != selectedItem)
				{
					((Picker)b).SelectedItem = selectedItem;
				}
			}
		});

		public DateTime SelectedDate
		{
			get { return (DateTime)this.GetValue(SelectedDateProperty); }
			set { this.SetValue(SelectedDateProperty, value); }
		}
    }
}
