
using Syncfusion.SfPicker.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace picker132913
{
	public class CustomTimePicker : SfPicker
	{
		public ObservableCollection<object> Time { get; set; }
		public ObservableCollection<object> Minute;
		public ObservableCollection<object> Hour;
		public ObservableCollection<object> Format;

		public ObservableCollection<string> Headers { get; set; }
		public CustomTimePicker()
		{
            this.HeaderText = "TimePicker";
            this.ShowFooter = true;
			Time = new ObservableCollection<object>();
			Hour = new ObservableCollection<object>();
			Minute = new ObservableCollection<object>();
			Format = new ObservableCollection<object>();
			Headers = new ObservableCollection<string>();
			if (Device.OS == TargetPlatform.Android)
			{
				Headers.Add("HOUR");
				Headers.Add("MINUTE");
				Headers.Add("MERIDIEM");
			}
			else
			{
				Headers.Add("Hour");
				Headers.Add("Minute");
				Headers.Add("Meridiem");
			}
			PopulateTimeCollection();

			this.ItemsSource = Time;
            var h = DateTime.Now.Hour;
            var mer = "AM";
            if(h>12)
            {
                h = h - 12;
                mer = "PM";
            }
            var m = DateTime.Now.Minute;
            ObservableCollection<object> coll = new System.Collections.ObjectModel.ObservableCollection<object>();
            coll.Add(h.ToString());
            coll.Add(m.ToString());
            coll.Add(mer.ToString());
            this.SelectedItem=coll;
			this.ColumnHeaderText = Headers;
            this.ShowColumnHeader = true;
            this.ShowHeader = true;
		}

		private void PopulateTimeCollection()
		{
			for (int i = 1; i <= 12; i++)
			{
				Hour.Add(i.ToString());
			}
			for (int j = 0; j < 60; j++)
			{
				if (j < 10)
				{
					Minute.Add("0" + j);
				}
				else
					Minute.Add(j.ToString());
			}

			Format.Add("AM");
			Format.Add("PM");

			Time.Add(Hour);
			Time.Add(Minute);
			Time.Add(Format);
		}
	}
}
